/*
    vg^CvRPG 05
   2005/ 3/23  ˁ@P
*/
#include <windows.h>
#include <mmsystem.h>
#include <time.h>
#include <stdlib.h>
#include <math.h>
#include <process.h>

#pragma comment(lib, "winmm.lib")

#define GAME_WIDTH 640
#define GAME_HEIGHT 480

#define KEY_NONE  0
#define KEY_UP    1
#define KEY_LEFT  3
#define KEY_DOWN  5
#define KEY_RIGHT 7
#define KEY_A     10

#define MODE_NORMAL  0
#define MODE_SCROLL  1
#define MODE_MESSAGE 2
#define MODE_BATTLE  3
 
#define CODE_LET      0x00
#define CODE_LETR     0x01
#define CODE_INC      0x10
#define CODE_DEC      0x11
#define CODE_ADD      0x12
#define CODE_SUB      0x13
#define CODE_ADDR     0x14
#define CODE_SUBR     0x15
#define CODE_JP       0x20
#define CODE_JPEQ     0x21
#define CODE_JPEQR    0x22
#define CODE_JPLT     0x23
#define CODE_JPLTR    0x24
#define CODE_JPGT     0x25
#define CODE_JPGTR    0x26
#define CODE_JPNEQ    0x27
#define CODE_MESSAGE  0x40
#define CODE_MESSAGER 0x41
#define CODE_DIALOG   0x50
#define CODE_BATTLE   0x60
#define CODE_MOVE     0x80
#define CODE_SETMAP   0x90
#define CODE_SETEVENT 0x91
#define CODE_SETINFO  0x92
#define CODE_HPMAX    0xa0
#define CODE_EXIT     0xff

#define DLG_YESNO  14
#define DLG_BATTLE 15

typedef struct { /* vC[\ */

	/* vC[ */
	char aszName[16];

	/* ʒu */
	int iX, iY;

	/* Xe[^X */
	int iHP, iHPMax;
	int iAT, iAC, iDEX;
	int iHPMaxL, iATL, iACL, iDEXL;
	int iEXP;

} CHR_STATUS;

typedef struct { /* G\ */

	char aszName[16];

	int iHP, iHPMax, iAT, iAC, iDEX, iEXP;

	/* 160*160sNZOtBbNf[^ */
	BYTE abyPixels[160 * 160 * 3];

} ENEMY;

typedef struct { /* Cxg\ */

	int iChrNo;
	int iType;

	/* R[hz */
	BYTE abyCode[64];

} EVENTDATA;

typedef struct { /* bZ[WEChE\ */

	char aszMessage[256];

	int iX, iY, iWidth, iHeight;
	RECT recWnd, recBG, recMes;

	HDC hdc;
	HFONT hfMes, hfOld;
	HBITMAP hbmpWnd, hbmpOld;

} MESWND;

typedef struct { /* _CAOEChE\ */

	LPTSTR alpszItem[4];
	char aszItems[128];

	int iX, iY;
	int iWidth, iHeight;
	int iItems, iItemHeight;

	RECT recWnd, recBG, arecItems[4];

	HDC hdc;
	HFONT hfItem, hfOld;
	HBITMAP hbmpWnd, hbmpOld;

} DLGWND;

HINSTANCE g_hInstance;
HWND g_hwMain;
HANDLE g_hGameThread;

unsigned g_dwGameThreadID;

/* XgOe[upϐ */
LPTSTR g_lpStringTable;
char * g_alpszString[256];

/* Q[rbg}bvpϐ */
HBITMAP g_hbmpGameOld, g_hbmpGame;
HDC g_hdcGame;

/* }bvrbg}bvpϐ */
BITMAPINFO g_biMap;
HBITMAP g_hbmpMapOld, g_hbmpMap;
LPDWORD g_lppxMap;
HDC g_hdcMap;

/* XN[rbg}bvpϐ */
HBITMAP g_hbmpScrollOld, g_hbmpScroll;
HDC g_hdcScroll;

/* }bv`bvECxgLN^OtBbNpϐ */
BITMAPINFO g_biMapParts;
LPDWORD g_lppxChr, g_lppxTip;

/* Xe[^Xrbg}bvpϐ */
HBITMAP g_hbmpStatusOld, g_hbmpStatus;
HDC g_hdcStatus;

/* 풆GOtBbNpϐ */
BITMAPINFO g_biEnemy;
LPBYTE g_lpp3Enemy;

HFONT g_hfStName, g_hfStStatus;

LPDWORD g_alppxTips[16];
LPDWORD g_alppxChr[16];
LPDWORD g_alppxPC[2];

/* CxgR[hpWX^ */
WORD g_awReg[16];

/* }bvz */
BYTE g_abyMap[256 * 256], g_abyInfo[256 * 256], g_abyEvent[256 * 256], g_abyEnemy[256 * 256];

/* Q[ԊǗϐ */
int g_iMode, g_iDialog, g_iBattle;

/* XN[ʐݒϐ */
DWORD g_dwScU;

/* XN[Ǘpϐ */
int g_iDx, g_iDy, g_iDdx, g_iDdy;

/* Q[ԃJE^ */
DWORD g_dwCount, g_dwTime;

EVENTDATA g_aevEvent[255];
ENEMY g_aenEnemy[16];

RECT g_recGame = {0, 0, GAME_WIDTH - 1, GAME_HEIGHT - 1};

CHR_STATUS g_status;
MESWND g_mwMessage;
DLGWND g_adlgDialog[16], *g_lpdlgDlg;
RECT g_recStatusIn, g_recStatusOut;

/* AvP[VItO */
volatile BOOL g_bExit;

unsigned WINAPI gameThread(LPVOID lpArg);

LRESULT CALLBACK WndProc(HWND, UINT, WPARAM, LPARAM);
BOOL game();
BOOL init();
BOOL setXY(int iX, int iY);
BOOL loadData();
BOOL loadData(LPCTSTR lpszFilePath);
BOOL setData(const LPBYTE lpBuf);
BOOL drawGame();
int getKey();
void drawMessage(LPCTSTR lpszMessage);
void drawStatus();
void showMessage(LPCTSTR lpszMessage);
BOOL initDialog(DLGWND *lpDlg, LPCTSTR lpszItem1, LPCTSTR lpszItem2, LPCTSTR lpszItem3, LPCTSTR lpszItem4, int iItems);
WORD dialog(int iNo);
WORD battle(ENEMY *lpEnemy);
void event(int iNo);
void execEventCode(LPBYTE lpbyCode);
void clcStatus();
BOOL destroy();

int WINAPI WinMain(HINSTANCE hInstance, HINSTANCE hPrevInstance,
                    PSTR szCmdLine, int iCmdShow){

	MSG  msg;
	WNDCLASS wndclass;

	/*  */
	init();

	g_hInstance = hInstance;

	wndclass.style         = CS_HREDRAW | CS_VREDRAW;
	wndclass.lpfnWndProc   = WndProc;
	wndclass.cbClsExtra    = 0;
	wndclass.cbWndExtra    = 0;
	wndclass.hInstance     = hInstance;
	wndclass.hIcon         = LoadIcon(NULL, IDI_APPLICATION);
	wndclass.hCursor       = LoadCursor(NULL, IDC_ARROW);
	wndclass.hbrBackground = (HBRUSH)GetStockObject(WHITE_BRUSH);
	wndclass.lpszMenuName  = NULL;
	wndclass.lpszClassName = "CWindow";

	RegisterClass(&wndclass);

	/* EChETCYvZ */
    AdjustWindowRect(&g_recGame, WS_OVERLAPPEDWINDOW, FALSE);

	/* EChE쐬 */
	g_hwMain = CreateWindow("CWindow", "vg^CvRPG",
	          WS_OVERLAPPEDWINDOW | WS_CLIPCHILDREN,
	          CW_USEDEFAULT, CW_USEDEFAULT,
			  g_recGame.right - g_recGame.left, g_recGame.bottom - g_recGame.top, 
	          NULL, NULL, hInstance, NULL);

	/* EChE\ */
	ShowWindow(g_hwMain, iCmdShow);
	UpdateWindow(g_hwMain);

	/* ItOZbg */
	g_bExit = FALSE;

	/* C[v */
	do {

		/* bZ[W */
		if (GetMessage(&msg, NULL, 0, 0) == 0) {
			g_bExit = TRUE;
		} else {

			TranslateMessage(&msg);
			DispatchMessage(&msg);

		}

	} while (!g_bExit);

	/* I */
	destroy();

	return (int)msg.wParam;

}

/* EChEvV[W[ */
LRESULT CALLBACK WndProc(HWND hwnd, UINT iMsg, WPARAM wParam, LPARAM lParam) {

	HDC hdc;
	PAINTSTRUCT ps;

	switch (iMsg) {

	case WM_CREATE:

		/* Q[XbhN */
		g_hGameThread = (HANDLE)_beginthreadex(NULL, 0, gameThread, NULL, 0, &g_dwGameThreadID);

		break;

	case WM_PAINT: /* `揈 */

		hdc = BeginPaint(hwnd, &ps);

		/* Q[ʂ` */
		BitBlt(hdc, 0, 0, GAME_WIDTH, GAME_HEIGHT,
		       g_hdcGame, 0, 0, SRCCOPY);

		EndPaint(hwnd, &ps);

		return 0;

	case WM_DESTROY: /* I */

		/* ItOZbg */
		g_bExit = TRUE;

		/* Q[XbhIҋ@ */
		if (WaitForSingleObject(g_hGameThread, 2000) != WAIT_OBJECT_0) {
			TerminateThread(g_hGameThread, 0);
		}

		/* Q[Xbh̃nh */
		CloseHandle(g_hGameThread);

		PostQuitMessage(0);

		return 0;

	}

	return DefWindowProc(hwnd, iMsg, wParam, lParam) ;

}

/* Q[Xbh */
unsigned WINAPI gameThread(LPVOID lpArg) {

	/* timeGetTime()̐xݒ */
	timeBeginPeriod(1);

	g_dwTime = timeGetTime();

	do {

		/* O񏈗8msȏoĂ΃Q[ */
		if (timeGetTime() - g_dwTime > 8) {

			/* Q[ */
			g_dwTime = timeGetTime();
			game();

		}

		Sleep(1);

	} while (!g_bExit);

	timeEndPeriod(1);

	return 0;

}

/* Q[C */
BOOL game() {

	int i;
	int iEventNo;
	int iDScroll;
	static int iDScrollPrev;

	static DWORD dwScrollStart;

	/* ݂̏ԂɉĐU蕪 */
	switch (g_iMode) {

	case MODE_NORMAL: /* ʏ */

		/* XN[JnԁijL */
		dwScrollStart = g_dwTime;

		iDScrollPrev = -1;

		switch (getKey()) { /* L[̓`FbN */

		case KEY_RIGHT: /* EL[ */

			/* i\ */
			if (g_abyInfo[g_status.iX + 1 + g_status.iY * 256] < 128) {

				/* XN[rbg}bvɐVɉ͈͂ɓ镔` */
				for (i = 0;i < 15;i++) {
					StretchDIBits(g_hdcScroll, 512, 32 + i * 32, 32, 32,
					  0, 0, 32, 32,
					  g_alppxTips[g_abyMap[g_status.iX + 8 + (g_status.iY - 7 + i) * 256]],
					  &g_biMapParts, DIB_RGB_COLORS, SRCCOPY);
				}

				/* XN[Jn */
				g_iDdx = 1;
				g_iMode = MODE_SCROLL;

			} else {

				/* L[̃Cxgԍ擾 */
				iEventNo = g_abyEvent[g_status.iX + 1 + g_status.iY * 256];

				/* ڐGCxg */
				if (iEventNo < 0xff && g_aevEvent[iEventNo].iType == 0) {
					event(iEventNo);
				}

			}

			break;

		case KEY_LEFT:  /* L[ */

			/* i\ */
			if (g_abyInfo[g_status.iX - 1 + g_status.iY * 256] < 128) {

				/* XN[rbg}bvɐVɉ͈͂ɓ镔` */
				for (i = 0;i < 15;i++) {
					StretchDIBits(g_hdcScroll, 0, 32 + i * 32, 32, 32,
					  0, 0, 32, 32,
					  g_alppxTips[g_abyMap[g_status.iX - 8 + (g_status.iY - 7 + i) * 256]],
					  &g_biMapParts, DIB_RGB_COLORS, SRCCOPY);
				}

				/* XN[Jn */
				g_iDdx = -1;
				g_iMode = MODE_SCROLL;

			} else {

				iEventNo = g_abyEvent[g_status.iX - 1 + g_status.iY * 256];

				/* ڐGCxg */
				if (iEventNo < 0xff && g_aevEvent[iEventNo].iType == 0) {
					event(iEventNo);
				}

			}

			break;

		case KEY_UP: /* L[ */

			/* i\ */
			if (g_abyInfo[g_status.iX + (g_status.iY - 1) * 256] < 128) {

				/* XN[rbg}bvɐVɉ͈͂ɓ镔` */
				for (i = 0;i < 15;i++) {
					StretchDIBits(g_hdcScroll, 32 + i * 32, 0, 32, 32,
					  0, 0, 32, 32,
					  g_alppxTips[g_abyMap[i + g_status.iX - 7 + (g_status.iY - 8) * 256]],
					  &g_biMapParts, DIB_RGB_COLORS, SRCCOPY);
				}

				/* XN[Jn */
				g_iDdy = -1;
				g_iMode = MODE_SCROLL;

			} else {

				iEventNo = g_abyEvent[g_status.iX + (g_status.iY - 1) * 256];

				/* ڐGCxg */
				if (iEventNo < 0xff && g_aevEvent[iEventNo].iType == 0) {
					event(iEventNo);
				}

			}

			break;

		case KEY_DOWN: /* L[ */

			/* i\ */
			if (g_abyInfo[g_status.iX + (g_status.iY + 1) * 256] < 128) {

				/* XN[rbg}bvɐVɉ͈͂ɓ镔` */
				for (i = 0;i < 15;i++) {
					StretchDIBits(g_hdcScroll, 32 + i * 32, 512, 32, 32,
					  0, 0, 32, 32,
					  g_alppxTips[g_abyMap[i + g_status.iX - 7 + (g_status.iY + 8) * 256]],
					  &g_biMapParts, DIB_RGB_COLORS, SRCCOPY);
				}

				/* XN[Jn */
				g_iDdy = 1;
				g_iMode = MODE_SCROLL;

			} else {

				iEventNo = g_abyEvent[g_status.iX + (g_status.iY + 1) * 256];

				/* ڐGCxg */
				if (iEventNo < 0xff && g_aevEvent[iEventNo].iType == 0) {
					event(iEventNo);
				}

			}

			break;

		default:

			Sleep(5);

		}

		break;

	case MODE_SCROLL: /* XN[ */

		/* XN[JňoߎԂɉăXN[ʒuZo */
		iDScroll = (g_dwTime - dwScrollStart) / g_dwScU;

		if (iDScroll > 32) {
			iDScroll = 32;
		}

		if (iDScroll < 0) {
			iDScroll = 32;
		}

		/* OƓ炻̂܂ܖ߂ */
		if (iDScroll == iDScrollPrev) {

			g_dwCount++;

			return TRUE;

		}

		iDScrollPrev = iDScroll;

		/* XN[rbg}bv`ʒuXV */
		g_iDx = 32 + g_iDdx * iDScroll;
		g_iDy = 32 + g_iDdy * iDScroll;

		/* EXN[I */
		if (g_iDdx == 1 && g_iDx == 64) {

			g_iDx = 32;
			g_iDdx = 0;

			g_status.iX++;
			g_iMode = MODE_NORMAL;

			/* XN[rbg}bvɌ݂̉͈͂`Ȃ */
			BitBlt(g_hdcScroll, 32, 32, 480, 480, g_hdcScroll, 64, 32, SRCCOPY);

		}

		/* XN[I */
		if (g_iDdx == -1 && g_iDx == 0) {

			g_iDx = 32;
			g_iDdx = 0;

			g_status.iX--;
			g_iMode = MODE_NORMAL;

			/* XN[rbg}bvɌ݂̉͈͂`Ȃ */
			BitBlt(g_hdcScroll, 32, 32, 480, 480, g_hdcScroll, 0, 32, SRCCOPY);

		}

		/* XN[I */
		if (g_iDdy == 1 && g_iDy == 64) {

			g_iDy = 32;
			g_iDdy = 0;

			g_status.iY++;
			g_iMode = MODE_NORMAL;

			/* XN[rbg}bvɌ݂̉͈͂`Ȃ */
			BitBlt(g_hdcScroll, 32, 32, 480, 480, g_hdcScroll, 32, 64, SRCCOPY);

		}

		/* XN[I */
		if (g_iDdy == -1 && g_iDy == 0) {

			g_iDy = 32;
			g_iDdy = 0;

			g_status.iY--;
			g_iMode = MODE_NORMAL;

			/* XN[rbg}bvɌ݂̉͈͂`Ȃ */
			BitBlt(g_hdcScroll, 32, 32, 480, 480, g_hdcScroll, 32, 0, SRCCOPY);

		}

		/* XN[ */
		if (g_iMode == MODE_NORMAL) {

			iDScrollPrev = -1;

			iEventNo = g_abyEvent[g_status.iX + g_status.iY * 256];

			/* iCxg */
			if (iEventNo < 0xff && g_aevEvent[iEventNo].iType == 1) {
				event(iEventNo);
			} else {
				/* G */
				if ((g_abyEnemy[g_status.iX + g_status.iY * 256] & 0x0f) > (rand() % 15)) {
					battle(&g_aenEnemy[g_abyEnemy[g_status.iX + g_status.iY * 256] >> 4]);
				}
			}

		}

		break;

	case MODE_MESSAGE: /* bZ[W\ */

		/* AL[͂ŒʏɕA */
		if (getKey() == KEY_A) {
			g_iMode = MODE_NORMAL;
		}

		Sleep(5);

		break;

	}

	g_dwCount++;

	if (!g_bExit) {

		drawGame();
		InvalidateRect(g_hwMain, NULL, FALSE);

	}

	return TRUE;

}

/* vC[ʒuݒ֐ */
BOOL setXY(int iX, int iY) {

	int i, j;

	if (iX < 0 || iX > 255 || iY < 0 || iY > 255) {
		return FALSE;
	}

	/* vC[ʒuݒ */
	g_status.iX = iX;
	g_status.iY = iY;

	/* vC[ʒuŃ}bv` */
	for (i = 0;i < 15;i++) {
		for (j = 0;j < 15;j++) {
			StretchDIBits(g_hdcScroll, j * 32 + 32, i * 32 + 32, 32, 32,
		    0, 0, 32, 32, g_alppxTips[g_abyMap[j + g_status.iX - 7 + (i + g_status.iY - 7) * 256]],
			&g_biMapParts, DIB_RGB_COLORS, SRCCOPY);
		}
	}

	return TRUE;

}

/* Q[ʕ`֐ */
BOOL drawGame() {

	int i, j, k, l, iChrNo, iEChr;
	int iEx, iEy;

	/* vC[Ajp^[ݒ */
	if (g_dwCount % 100 < 50) {
		iChrNo = 0;
	} else {
		iChrNo = 1;
	}

	/* }bvrbg}bvɌ݂̉͈͓}bv` */
	BitBlt(g_hdcMap, 0, 0, 480, 480, g_hdcScroll, g_iDx, g_iDy, SRCCOPY);

	if (g_iMode == MODE_SCROLL) { /* XN[ */

		/* CxgLN^}bvrbg}bvɕ` */
		for (i = 0;i < 17;i++) {
			for (j = 0;j < 17;j++) {
				if (g_abyEvent[g_status.iX + j - 8 + (g_status.iY + i - 8) * 256] != 0xff &&
					g_aevEvent[g_abyEvent[g_status.iX + j - 8 + (g_status.iY + i - 8) * 256]].iChrNo != 0xff) {

					/* CxgLN^̔ԍ擾 */
					iEChr = g_aevEvent[g_abyEvent[g_status.iX + j - 8 + (g_status.iY + i - 8) * 256]].iChrNo;

					/* CxgLN^1sNZߓ] */
					for (k = 0;k < 32;k++) {
						for (l = 0;l < 32;l++) {
							if (g_alppxChr[iEChr][l + k * 32] != 0) {

								iEx = j * 32 + l - g_iDx;
								iEy = i * 32 + k - g_iDy;

								if (iEx >= 0 && iEx < 480 &&
									iEy >= 0 && iEy < 480) {
									g_lppxMap[iEx + iEy * 480] =
									  g_alppxChr[iEChr][l + k * 32];
								}
			
							}
						}
					}

				}
			}
		}

	} else {

		/* CxgLN^}bvrbg}bvɕ` */
		for (i = 0;i < 15;i++) {
			for (j = 0;j < 15;j++) {
				if (g_abyEvent[g_status.iX + j - 7 + (g_status.iY + i - 7) * 256] != 0xff &&
					g_aevEvent[g_abyEvent[g_status.iX + j - 7 + (g_status.iY + i - 7) * 256]].iChrNo !=0xff) {

					iEChr = g_aevEvent[g_abyEvent[g_status.iX + j - 7 + (g_status.iY + i - 7) * 256]].iChrNo;

					for (k = 0;k < 32;k++) {
						for (l = 0;l < 32;l++) {
							if (g_alppxChr[iEChr][l + k * 32] != 0) {
								g_lppxMap[j * 32 + l + (i * 32 + k) * 480] =
								  g_alppxChr[iEChr][l + k * 32];
							}
						}

					}

				}
			}
		}

	}

	/* }bvrbg}bvɃvC[` */
	for (i = 0;i < 32;i++) {
		for (j = 0;j < 32;j++) {
			if (g_alppxPC[iChrNo][j + i * 32] != 0x00) {
				g_lppxMap[224 + j + (224 + i) * 480] =
				  g_alppxPC[iChrNo][j + i * 32];
			}
		}
	}

	if (g_iBattle == 1) { /* 퓬 */
		/* }bvrbg}bvɓGrbg}bv` */
		StretchDIBits(g_hdcMap, 160, 120, 160, 160,
		  0, 0, 160, 160, g_lpp3Enemy, &g_biEnemy,
		  DIB_RGB_COLORS, SRCCOPY);
	}

	if (g_iMode == MODE_MESSAGE) { /* bZ[W\ */
		/* }bvrbg}bvɃbZ[WEChE` */
		BitBlt(g_hdcMap, 32, 272, 416, 192,
		       g_mwMessage.hdc, 0, 0, SRCCOPY);
	}

	if (g_iDialog == 1) { /* _CAO\ */
		/* }bvrbg}bvɃ_CAOEChE` */
		BitBlt(g_hdcMap, g_lpdlgDlg->iX, g_lpdlgDlg->iY, g_lpdlgDlg->iWidth, g_lpdlgDlg->iHeight,
		       g_lpdlgDlg->hdc, 0, 0, SRCCOPY);
	}

	/* Q[rbg}bvɃ}bvrbg}bv` */
	BitBlt(g_hdcGame, 0, 0, 480, 480, g_hdcMap, 0, 0, SRCCOPY);

	if (g_iMode != MODE_SCROLL) {

		/* Xe[^X` */
		drawStatus();

		/* Q[rbg}bvɃXe[^Xrbg}bv` */
		BitBlt(g_hdcGame, 480, 0, 160, 480, g_hdcStatus, 0, 0, SRCCOPY);

	}

	return TRUE;

}

/* A^CL[͔ */
int getKey() {

	int iX, iY, iKey;

	/* tHAOhłȂ΃L[͖ */
	if (GetForegroundWindow() != g_hwMain) {
		return KEY_NONE;
	}

	/* Xy[XL[ */
	if (GetAsyncKeyState(VK_SPACE) < 0) {
		return KEY_A;
	}

	iX = 0;
	iY = 0;
	iKey = KEY_NONE;

	/* J[\L[ */
	if (GetAsyncKeyState(VK_UP) < 0) {
		iY--;
	}

	/* J[\L[ */
	if (GetAsyncKeyState(VK_LEFT) < 0) {
		iX++;
	}

	/* J[\L[ */
	if (GetAsyncKeyState(VK_DOWN) < 0) {
		iY++;
	}

	/* EJ[\L[ */
	if (GetAsyncKeyState(VK_RIGHT) < 0) {
		iX--;
	}

	if (iX != 0 && iY != 0) {
		iKey = KEY_NONE;
	}

	if (iY == -1) {
		iKey = KEY_UP;
	}

	if (iX == 1) {
		iKey = KEY_LEFT;
	}

	if (iY == 1) {
		iKey = KEY_DOWN;
	}

	if (iX == -1) {
		iKey = KEY_RIGHT;
	}

	return iKey;

}

/* bZ[WEChE\֐ */
void showMessage(LPCTSTR lpszMessage) {

	/* bZ[WEChE` */
	drawMessage(lpszMessage);

	/* bZ[W[hֈڍs */
	g_iMode = MODE_MESSAGE;

}

/* bZ[WEChE`֐ */
void drawMessage(LPCTSTR lpszMessage) {

	/* \ݒ */
	lstrcpy(g_mwMessage.aszMessage, lpszMessage);

	SetBkMode(g_mwMessage.hdc, TRANSPARENT);
	SetTextColor(g_mwMessage.hdc, 0x00ffffff);

	/* bZ[WEChENA */
	FillRect(g_mwMessage.hdc, &g_mwMessage.recWnd, (HBRUSH)GetStockObject(WHITE_BRUSH));
	FillRect(g_mwMessage.hdc, &g_mwMessage.recBG, (HBRUSH)GetStockObject(BLACK_BRUSH));

	/* bZ[W` */
	DrawText(g_mwMessage.hdc, lpszMessage, -1, &g_mwMessage.recMes, DT_LEFT | DT_TOP | DT_WORDBREAK);

}

/* Xe[^X`֐ */
void drawStatus() {

	RECT recTmp;
	char aszTmp[64];
	HFONT hfOld;

	/* wiNA */
	FillRect(g_hdcStatus, &g_recStatusIn, (HBRUSH)GetStockObject(BLACK_BRUSH));

	SetBkMode(g_hdcStatus, TRANSPARENT);
	SetTextColor(g_hdcStatus, 0x00ffffff);

	recTmp.left = 2;
	recTmp.top = 8;
	recTmp.right = 157;
	recTmp.bottom = 32;

	hfOld = (HFONT)SelectObject(g_hdcStatus, g_hfStName);

	/* vC[` */
	DrawText(g_hdcStatus, g_status.aszName, -1, &recTmp, DT_CENTER | DT_SINGLELINE | DT_VCENTER);

	SelectObject(g_hdcStatus, g_hfStStatus);

	lstrcpy(aszTmp, "̗");
	recTmp.left = 2;
	recTmp.top = 40;
	recTmp.right = 60;
	recTmp.bottom = 64;

	DrawText(g_hdcStatus, aszTmp, -1, &recTmp, DT_CENTER | DT_SINGLELINE | DT_VCENTER);

	lstrcpy(aszTmp, "/");
	recTmp.left = 96;
	recTmp.top = 40;
	recTmp.right = 112;
	recTmp.bottom = 64;

	DrawText(g_hdcStatus, aszTmp, -1, &recTmp, DT_CENTER | DT_SINGLELINE | DT_VCENTER);

	wsprintf(aszTmp, "%d", g_status.iHP);
	recTmp.left = 64;
	recTmp.top = 40;
	recTmp.right = 94;
	recTmp.bottom = 64;

	DrawText(g_hdcStatus, aszTmp, -1, &recTmp, DT_RIGHT | DT_SINGLELINE | DT_VCENTER);

	wsprintf(aszTmp, "%d", g_status.iHPMax);
	recTmp.left = 114;
	recTmp.top = 40;
	recTmp.right = 154;
	recTmp.bottom = 64;

	DrawText(g_hdcStatus, aszTmp, -1, &recTmp, DT_LEFT | DT_SINGLELINE | DT_VCENTER);

	lstrcpy(aszTmp, "ol");
	recTmp.left = 2;
	recTmp.top = 72;
	recTmp.right = 60;
	recTmp.bottom = 96;

	DrawText(g_hdcStatus, aszTmp, -1, &recTmp, DT_CENTER | DT_SINGLELINE | DT_VCENTER);

	wsprintf(aszTmp, "%d", g_status.iEXP);
	recTmp.left = 80;
	recTmp.top = 72;
	recTmp.right = 154;
	recTmp.bottom = 96;

	DrawText(g_hdcStatus, aszTmp, -1, &recTmp, DT_LEFT | DT_SINGLELINE | DT_VCENTER);

	lstrcpy(aszTmp, "U");
	recTmp.left = 2;
	recTmp.top = 104;
	recTmp.right = 60;
	recTmp.bottom = 128;

	DrawText(g_hdcStatus, aszTmp, -1, &recTmp, DT_CENTER | DT_SINGLELINE | DT_VCENTER);

	wsprintf(aszTmp, "%d", g_status.iAT);
	recTmp.left = 80;
	recTmp.top = 104;
	recTmp.right = 154;
	recTmp.bottom = 128;

	DrawText(g_hdcStatus, aszTmp, -1, &recTmp, DT_LEFT | DT_SINGLELINE | DT_VCENTER);

	lstrcpy(aszTmp, "");
	recTmp.left = 2;
	recTmp.top = 136;
	recTmp.right = 60;
	recTmp.bottom = 160;

	DrawText(g_hdcStatus, aszTmp, -1, &recTmp, DT_CENTER | DT_SINGLELINE | DT_VCENTER);

	wsprintf(aszTmp, "%d", g_status.iAC);
	recTmp.left = 80;
	recTmp.top = 136;
	recTmp.right = 154;
	recTmp.bottom = 160;

	DrawText(g_hdcStatus, aszTmp, -1, &recTmp, DT_LEFT | DT_SINGLELINE | DT_VCENTER);

	lstrcpy(aszTmp, "q");
	recTmp.left = 2;
	recTmp.top = 168;
	recTmp.right = 60;
	recTmp.bottom = 192;

	DrawText(g_hdcStatus, aszTmp, -1, &recTmp, DT_CENTER | DT_SINGLELINE | DT_VCENTER);

	wsprintf(aszTmp, "%d", g_status.iDEX);
	recTmp.left = 80;
	recTmp.top = 168;
	recTmp.right = 154;
	recTmp.bottom = 192;

	DrawText(g_hdcStatus, aszTmp, -1, &recTmp, DT_LEFT | DT_SINGLELINE | DT_VCENTER);

	/* y̑Iɖ߂ */
	SelectObject(g_hdcStatus, hfOld);

}

/* _CAOEChE쐬֐ */
BOOL initDialog(DLGWND *lpDlg, LPCTSTR lpszItem1, LPCTSTR lpszItem2, LPCTSTR lpszItem3, LPCTSTR lpszItem4, int iItems) {

	int i;
	int iWidth, iHeight;
	RECT recTmp;
	LPCTSTR lpszItems[4];
	HDC hdc;

	if (lpDlg == NULL || iItems < 1) {
		return FALSE;
	}

	hdc = GetDC(0);

	lpDlg->hdc = CreateCompatibleDC(hdc);
	SetBkMode(lpDlg->hdc, TRANSPARENT);

	/* _CAOIptHg쐬 */
	lpDlg->hfItem = CreateFont(18, 0, 0, 0, FW_NORMAL, 0, 0, 0, SHIFTJIS_CHARSET,
	                      OUT_DEFAULT_PRECIS, CLIP_DEFAULT_PRECIS, DEFAULT_QUALITY, 
						  FF_DONTCARE | DEFAULT_PITCH, NULL);

	lpDlg->hfOld = (HFONT)SelectObject(lpDlg->hdc, lpDlg->hfItem);

	lpDlg->iItemHeight = 24;

	/* I|C^ݒ */
	for (i = 0;i < 4;i++) {
		lpDlg->alpszItem[i] = lpDlg->aszItems + i * 32;
	}

	lpszItems[0] = lpszItem1;
	lpszItems[1] = lpszItem2;
	lpszItems[2] = lpszItem3;
	lpszItems[3] = lpszItem4;

	/* Iݒ */
	for (i = 0;i < iItems;i++) {
		lstrcpy(lpDlg->alpszItem[i], lpszItems[i]);
	}

	/* Iݒ */
	lpDlg->iItems = iItems;

	/* ȑÕrbg}bv폜 */
	if (lpDlg->hbmpWnd != NULL) {

		SelectObject(lpDlg->hdc, lpDlg->hbmpOld);
		DeleteObject(lpDlg->hbmpWnd);

	}

	iWidth = 0;

	/* Ỉ擾 */
	for (i = 0;i < lpDlg->iItems;i++) {

		recTmp.left = 0;
		recTmp.top = 0;

		DrawText(lpDlg->hdc, lpDlg->alpszItem[i], -1, &recTmp, DT_CALCRECT | DT_SINGLELINE);

		if (iWidth < recTmp.right) {
			iWidth = recTmp.right;
		}

	}

	iWidth += 4 + 16;
	lpDlg->iWidth = iWidth;

	iHeight = 4 + 24 * lpDlg->iItems;
	lpDlg->iHeight = iHeight;

	/* _CAÖݒ */
	lpDlg->recWnd.left = 0;
	lpDlg->recWnd.top = 0;
	lpDlg->recWnd.right = iWidth;
	lpDlg->recWnd.bottom = iHeight;

	lpDlg->recBG.left = 2;
	lpDlg->recBG.top = 2;
	lpDlg->recBG.right = iWidth - 2;
	lpDlg->recBG.bottom = iHeight - 2;

	lpDlg->iX = 240 - iWidth / 2;
	lpDlg->iY = 256 - iHeight;

	/* `prbg}bv쐬 */
	lpDlg->hbmpWnd = CreateCompatibleBitmap(hdc, iWidth, iHeight);

	lpDlg->hbmpOld = (HBITMAP)SelectObject(lpDlg->hdc, lpDlg->hbmpWnd);

	FillRect(lpDlg->hdc, &(lpDlg->recWnd), (HBRUSH)GetStockObject(WHITE_BRUSH));

	return TRUE;

}

/* I_CAO\֐ */
WORD dialog(int iNo) {

	WORD wResult, wIndex;
	int i;
	DWORD dwTime;

	wIndex = 0;

	g_iDialog = 1;
	g_lpdlgDlg = &g_adlgDialog[iNo];

	dwTime = GetTickCount();
	wResult = 0xffff;

	do {

		if (GetTickCount() - dwTime > 15) {

			dwTime = GetTickCount();

			FillRect(g_lpdlgDlg->hdc, &(g_lpdlgDlg->recBG), (HBRUSH)GetStockObject(BLACK_BRUSH));

			/* Iĕ` */
			for (i = 0;i < g_lpdlgDlg->iItems;i++) {

				if (i == wIndex) { /* ݈ʒȗI */

					/* Dnɍ */
					FillRect(g_lpdlgDlg->hdc, &(g_lpdlgDlg->arecItems[i]), (HBRUSH)GetStockObject(LTGRAY_BRUSH));
					SetTextColor(g_lpdlgDlg->hdc, 0x00000000);

				} else { /* ȊȎI */

					/* nɔ */
					FillRect(g_lpdlgDlg->hdc, &(g_lpdlgDlg->arecItems[i]), (HBRUSH)GetStockObject(BLACK_BRUSH));
					SetTextColor(g_lpdlgDlg->hdc, 0x00ffffff);

				}

				g_lpdlgDlg->arecItems[i].left = 4;
				g_lpdlgDlg->arecItems[i].top = 4 + i * g_lpdlgDlg->iItemHeight;
				g_lpdlgDlg->arecItems[i].right = g_lpdlgDlg->iWidth - 4;
				g_lpdlgDlg->arecItems[i].bottom = 2 + i * g_lpdlgDlg->iItemHeight + g_lpdlgDlg->iItemHeight;

				DrawText(g_lpdlgDlg->hdc, g_lpdlgDlg->alpszItem[i], -1, &(g_lpdlgDlg->arecItems[i]), DT_LEFT);

			}

			drawGame();
			InvalidateRect(g_hwMain, NULL, FALSE);

			switch (getKey()) { /* L[͂ɉđIړEI */

			case KEY_UP:

				if (wIndex > 0) {
	
					wIndex--;
					Sleep(100);

				}

				break;

			case KEY_DOWN:

				if (wIndex < g_lpdlgDlg->iItems - 1) {

					wIndex++;
					Sleep(100);

				}

				break;

			case KEY_A:

				wResult = wIndex;

				break;

			}

		}

		Sleep(1);

	} while (!g_bExit && wResult == 0xffff);

	i = 0;

	/* AL[̂҂ */
	do {
		Sleep(100);		
	} while (!g_bExit && ++i < 10 && getKey() == KEY_A);

	g_iDialog = 0;

	return wResult;

}

/* 퓬 */
WORD battle(ENEMY *lpEnemy) {

	WORD wResult;

	char aszMessage[256], aszTmp[256];
	int iCommand, iMode;
	int i;
	int iEnHP, iEnAT, iEnAC, iEnDEX, iEnEXP;
	int iHeroDamage, iEnDamage;

	iEnHP = lpEnemy->iHP;
	iEnAT = lpEnemy->iAT;
	iEnAC = lpEnemy->iAC;
	iEnDEX = lpEnemy->iDEX;
	iEnEXP = lpEnemy->iEXP;

	wResult = 0;

	wsprintf(aszTmp, "%sƑI", lpEnemy->aszName);
	g_lpp3Enemy = lpEnemy->abyPixels;

	showMessage(aszTmp);

	/* 퓬tOZbg */
	g_iBattle = 1;

	iMode = -1;

	do {

		switch (iMode) {

		case -1: /* bZ[W\ */

			if (getKey() == KEY_A) {
				iMode = 0;
			}

			break;

		case 0: /* bZ[W\ */

			if (getKey() == KEY_A) {

				i = 0;
				iMode = 1;

			}

			break;

		case 1: /* sI */

			showMessage("ǂ܂@");

			if (getKey() != KEY_A) {
	
				iCommand = dialog(DLG_BATTLE);

				switch (iCommand) { /* IsŐU蕪 */

				case 0: /* U */

					/* _[WvZ */
					iEnDamage = (g_status.iAT / iEnAC) + rand() % (int)sqrt(g_status.iAT / 2);
					iHeroDamage = (iEnAT / g_status.iAC)+ rand() % (int)sqrt(iEnAT / 2);

					wsprintf(aszTmp, "%s̍UI\r\n%s%d̃_[W\r\n\r\n",
					         g_status.aszName, lpEnemy->aszName, iEnDamage);
					
					lstrcpy(aszMessage, aszTmp);
						
					iEnHP -= iEnDamage;

					if (iEnHP <= 0) { /*  */

						wsprintf(aszTmp, "%s|I\r\n",
						         lpEnemy->aszName);

						lstrcat(aszMessage, aszTmp);

						g_status.iEXP += iEnEXP + 1;

						wResult = 1;

					} else {

						wsprintf(aszTmp, "%s̍UI\r\n%s%d̃_[W\r\n",
					         lpEnemy->aszName, g_status.aszName, iHeroDamage);

						lstrcat(aszMessage, aszTmp);

						g_status.iHP -= iHeroDamage;

						if (g_status.iHP < 0) {
							g_status.iHP = 0;
						}

					}

					showMessage(aszMessage);

					iMode = 0;

					break;

				case 1: /*  */

					showMessage("܂");

					wResult = 3;

					Sleep(200);

					break;

				}

			}

			break;

		}

		drawGame();
		InvalidateRect(g_hwMain, NULL, FALSE);

		Sleep(2);

		if (g_bExit) {
			return 0;
		}

	} while (wResult == 0);

	g_iBattle = 0;

	/* Xe[^XČvZ */
	clcStatus();

	return wResult;

}

/* ֐ */
BOOL init() {

	HDC hdc;
	int i;

	/* }bv`bvA}bvn`A}bvCxgeNA */
	for (i = 0;i < 256 * 256;i++) {

		g_abyMap[i] = 0;
		g_abyInfo[i] = 0;
		g_abyEvent[i] = 0;

	}

	/* _CAONA */
	for (i = 0;i < 16;i++) {
		g_adlgDialog[i].iItems = 0;
	}

	ZeroMemory(&g_biEnemy, sizeof(g_biEnemy));

	/* GOtBbNpBITMAPINFOݒ */
	g_biEnemy.bmiHeader.biSize = sizeof(BITMAPINFOHEADER);
	g_biEnemy.bmiHeader.biWidth = 160;
	g_biEnemy.bmiHeader.biHeight = -160;
	g_biEnemy.bmiHeader.biPlanes = 1;
	g_biEnemy.bmiHeader.biBitCount = 24;
	g_biEnemy.bmiHeader.biCompression = BI_RGB;

	ZeroMemory(&g_biMap, sizeof(g_biMap));

	/* }bv\pBITMAPINFOݒ */
	g_biMap.bmiHeader.biSize = sizeof(BITMAPINFOHEADER);
	g_biMap.bmiHeader.biWidth = 480;
	g_biMap.bmiHeader.biHeight = -480;
	g_biMap.bmiHeader.biPlanes = 1;
	g_biMap.bmiHeader.biBitCount = 32;
	g_biMap.bmiHeader.biCompression = BI_RGB;

	ZeroMemory(&g_biMapParts, sizeof(g_biMapParts));

	/* }bv`bvELN^\pBITMAPINFOݒ */
	g_biMapParts.bmiHeader.biSize = sizeof(BITMAPINFOHEADER);
	g_biMapParts.bmiHeader.biWidth = 32;
	g_biMapParts.bmiHeader.biHeight = -32;
	g_biMapParts.bmiHeader.biPlanes = 1;
	g_biMapParts.bmiHeader.biBitCount = 32;
	g_biMapParts.bmiHeader.biCompression = BI_RGB;

	hdc = GetDC(0);

	/* bZ[WEChEprbg}bv쐬 */
	g_mwMessage.hbmpWnd = CreateCompatibleBitmap(hdc,  416, 200);
	g_mwMessage.hdc = CreateCompatibleDC(hdc);
	g_mwMessage.hbmpOld = (HBITMAP)SelectObject(g_mwMessage.hdc, g_mwMessage.hbmpWnd);

	/* bZ[WEChES̗̈ݒ */
	g_mwMessage.recWnd.left = 0;
	g_mwMessage.recWnd.top = 0;
	g_mwMessage.recWnd.right = 415;
	g_mwMessage.recWnd.bottom = 191;

	/* bZ[WEChEwïݒ */
	g_mwMessage.recBG.left = 2;
	g_mwMessage.recBG.top = 2;
	g_mwMessage.recBG.right = 413;
	g_mwMessage.recBG.bottom = 189;

	/* bZ[WEChEbZ[W`̈ݒ */
	g_mwMessage.recMes.left = 4;
	g_mwMessage.recMes.top = 4;
	g_mwMessage.recMes.right = 411;
	g_mwMessage.recMes.bottom = 187;

	/* bZ[W`ptHg쐬 */
	g_mwMessage.hfMes = CreateFont(18, 0, 0, 0, FW_NORMAL, 0, 0, 0, SHIFTJIS_CHARSET,
	                      OUT_DEFAULT_PRECIS, CLIP_DEFAULT_PRECIS, DEFAULT_QUALITY, 
						  FF_DONTCARE | DEFAULT_PITCH, NULL);

	g_mwMessage.hfOld = (HFONT)SelectObject(g_mwMessage.hdc, g_mwMessage.hfMes);

	/* Q[ʕ`prbg}bv쐬 */
	g_hbmpGame = CreateCompatibleBitmap(hdc, GAME_WIDTH, GAME_HEIGHT);
	g_hdcGame = CreateCompatibleDC(hdc);

	g_hbmpGameOld = (HBITMAP)SelectObject(g_hdcGame, g_hbmpGame);

	g_hbmpMap = CreateDIBSection(hdc, &g_biMap,
	            DIB_RGB_COLORS, (LPVOID *)(&g_lppxMap), NULL, 0);
	g_hdcMap = CreateCompatibleDC(hdc);
	g_hbmpMapOld = (HBITMAP)SelectObject(g_hdcMap, g_hbmpMap);

	g_recStatusOut.left = 0;
	g_recStatusOut.top = 0;
	g_recStatusOut.right = 160;
	g_recStatusOut.bottom = 480;

	g_recStatusIn.left = 2;
	g_recStatusIn.top = 2;
	g_recStatusIn.right = 157;
	g_recStatusIn.bottom = 477;

	/* Xe[^X`prbg}bv쐬 */
	g_hbmpStatus = CreateCompatibleBitmap(hdc, 160, 480);
	g_hdcStatus = CreateCompatibleDC(hdc);
	g_hbmpStatusOld = (HBITMAP)SelectObject(g_hdcStatus, g_hbmpStatus);
	FillRect(g_hdcStatus, &g_recStatusOut, (HBRUSH)GetStockObject(WHITE_BRUSH));

	/* Xe[^ẌvC[ptHg쐬 */
	g_hfStName = CreateFont(18, 0, 0, 0, FW_NORMAL, 0, 0, 0, SHIFTJIS_CHARSET,
	                      OUT_DEFAULT_PRECIS, CLIP_DEFAULT_PRECIS, DEFAULT_QUALITY, 
						  FF_DONTCARE | DEFAULT_PITCH, NULL);

	/* Xe[^ẌXe[^XptHg쐬 */
	g_hfStStatus = CreateFont(14, 0, 0, 0, FW_NORMAL, 0, 0, 0, SHIFTJIS_CHARSET,
	                      OUT_DEFAULT_PRECIS, CLIP_DEFAULT_PRECIS, DEFAULT_QUALITY, 
						  FF_DONTCARE | DEFAULT_PITCH, NULL);

	/* }bvXN[prbg}bv쐬 */
	g_hbmpScroll = CreateCompatibleBitmap(hdc, 544, 544);
	g_hdcScroll = CreateCompatibleDC(hdc);

	g_hbmpScrollOld = (HBITMAP)SelectObject(g_hdcScroll, g_hbmpScroll);

	/* vC[ECxgLN^psNZobt@m */
	g_lppxChr = (LPDWORD)HeapAlloc(GetProcessHeap(), HEAP_ZERO_MEMORY, 4096 * 18);

	/* CxgLN^psNZobt@𕪔z */
	for (i = 0;i < 16;i++) {
		g_alppxChr[i] = g_lppxChr + 32 * 32 * i;
	}

	/* vC[psNZobt@𕪔z */
	g_alppxPC[0] = g_lppxChr + 1024 * 16;
	g_alppxPC[1] = g_lppxChr + 1024 * 17;

	/* }bv`bvpsNZobt@m */
	g_lppxTip = (LPDWORD)HeapAlloc(GetProcessHeap(), HEAP_ZERO_MEMORY, 4096 * 16);

	/* }bv`bvpsNZobt@𕪔z */
	for (i = 0;i < 16;i++) {
		g_alppxTips[i] = g_lppxTip + i * 1024;
	}

	/* e[upobt@m */
	g_lpStringTable = (char *)HeapAlloc(GetProcessHeap(), HEAP_ZERO_MEMORY, 256 * 256);

	/* e[upobt@𕪔z */
	for (i = 0;i < 256;i++) {
		g_alpszString[i] = g_lpStringTable + i * 256;
	}

	/* f[^t@Cǂݍ */
	if (!loadData("test.dat")) {
		return FALSE;
	}

	/* vC[ꏉ */
	setXY(g_status.iX, g_status.iY);

	/* Q[ԊǗϐ */
	g_iMode = MODE_NORMAL;
	g_iDialog = 0;
	g_iBattle = 0;

	/* XN[Ǘpϐ */
	g_iDx = 32;
	g_iDy = 32;
	g_iDdx = 0;
	g_iDdy = 0;

	/* XN[1sNZ30msPʂ */
	g_dwScU = 30;

	return TRUE;

}

/* f[^t@Cǂݍ */
BOOL loadData(LPCTSTR lpszFilePath) {

	DWORD dwLoad, dwSize;
	HANDLE fh;
	LPBYTE lpBuf;

	/* t@CI[v */
	fh = CreateFile(lpszFilePath, GENERIC_READ, 0, NULL, OPEN_EXISTING,
		FILE_ATTRIBUTE_NORMAL, NULL); /* t@CI[v */

	if (fh == INVALID_HANDLE_VALUE) {
		return FALSE;
	}

	dwSize = GetFileSize(fh, NULL);

	/* t@Cǂݍ݃obt@m */
	lpBuf = (LPBYTE)HeapAlloc(GetProcessHeap(), 0, dwSize);

	/* t@Cǂݍ */
	ReadFile(fh, lpBuf, dwSize, &dwLoad, NULL);

	CloseHandle(fh);

	/* ǂݍ񂾃f[^Q[f[^ɐݒ */
	setData(lpBuf);

	return TRUE;

}

/* Q[f[^ݒ */
BOOL setData(const LPBYTE lpBuf) {

	int iOffset, iHeroOffset, iMapTipOffset, iMapDataOffset;
	int iDialogOffset, iStringTableOffset, iEventOffset, iMapEventOffset, iMapEnemyOffset;
	int iChrPixelOffset, iEnemyOffset, iMapInfoOffset;
	int i, j, k, l;

	LPBYTE lppxBMP;
	LPDWORD lppxParts, lppxChr;

	/* WX^ */
	for (i = 0;i < 16;i++) {
		g_awReg[i] = 0;
	}

	/* ef[^܂ł̃ItZbgݒ */
	CopyMemory(&iOffset, lpBuf + 4, 4);
	CopyMemory(&iHeroOffset, lpBuf + iOffset, 4);
	CopyMemory(&iEventOffset, lpBuf + iOffset + 4, 4);
	CopyMemory(&iEnemyOffset, lpBuf + iOffset + 8, 4);
	CopyMemory(&iDialogOffset, lpBuf + iOffset + 12, 4);
	CopyMemory(&iStringTableOffset, lpBuf + iOffset + 16, 4);
	CopyMemory(&iMapTipOffset, lpBuf + iOffset + 20, 4);
	CopyMemory(&iChrPixelOffset, lpBuf + iOffset + 24, 4);
	CopyMemory(&iMapDataOffset, lpBuf + iOffset + 28, 4);
	CopyMemory(&iMapEventOffset, lpBuf + iOffset + 32, 4);
	CopyMemory(&iMapEnemyOffset, lpBuf + iOffset + 36, 4);
	CopyMemory(&iMapInfoOffset, lpBuf + iOffset + 40, 4);

	/* vC[ݒ */
	CopyMemory(g_status.aszName, lpBuf + iHeroOffset, 16);

	/* vC[Xe[^Xݒ */
	CopyMemory(&g_status.iHP, lpBuf + iHeroOffset + 16, 4);
	CopyMemory(&g_status.iHPMax, lpBuf + iHeroOffset + 20, 4);
	CopyMemory(&g_status.iHPMaxL, lpBuf + iHeroOffset + 20, 4);
	CopyMemory(&g_status.iATL, lpBuf + iHeroOffset + 24, 4);
	CopyMemory(&g_status.iAT, lpBuf + iHeroOffset + 24, 4);
	CopyMemory(&g_status.iACL, lpBuf + iHeroOffset + 28, 4);
	CopyMemory(&g_status.iAC, lpBuf + iHeroOffset + 28, 4);
	CopyMemory(&g_status.iDEX, lpBuf + iHeroOffset + 32, 4);
	CopyMemory(&g_status.iDEXL, lpBuf + iHeroOffset + 32, 4);
	CopyMemory(&g_status.iEXP, lpBuf + iHeroOffset + 36, 4);
	CopyMemory(&g_status.iX, lpBuf + iHeroOffset + 40, 4);
	CopyMemory(&g_status.iY, lpBuf + iHeroOffset + 44, 4);

	/* vC[sNZݒ */
	for (i = 0;i < 32;i++) {
		for (j = 0;j < 32;j++) {

			CopyMemory(g_alppxPC[0] + (31 - i) * 32 + j, lpBuf + iHeroOffset + 48 + i * 32 * 3 + j * 3, 3);
			CopyMemory(g_alppxPC[1] + (31 - i) * 32 + j, lpBuf + iHeroOffset + 48 + 32 * 32 * 3 + i * 32 * 3 + j * 3, 3);

		}
	}

	/* Cxgf[^ݒ */
	for (i = 0;i < 255;i++) {

		g_aevEvent[i].iChrNo = lpBuf[iEventOffset + i * 66]; 
		g_aevEvent[i].iType = lpBuf[iEventOffset + 1 + i * 66]; 

		CopyMemory(g_aevEvent[i].abyCode, lpBuf + iEventOffset + 2 + i * 66, 64);

	}

	/* Gݒ */
	for (i = 0;i < 16;i++) {

		CopyMemory(g_aenEnemy[i].aszName, lpBuf + iEnemyOffset + (16 + 24 + 160 * 160 * 3) * i, 16);
		CopyMemory(&g_aenEnemy[i].iHP, lpBuf + iEnemyOffset + (16 + 24 + 160 * 160 * 3) * i + 16, 4);
		CopyMemory(&g_aenEnemy[i].iHPMax, lpBuf + iEnemyOffset + (16 + 24 + 160 * 160 * 3) * i + 20, 4);
		CopyMemory(&g_aenEnemy[i].iAT, lpBuf + iEnemyOffset + (16 + 24 + 160 * 160 * 3) * i + 24, 4);
		CopyMemory(&g_aenEnemy[i].iAC, lpBuf + iEnemyOffset + (16 + 24 + 160 * 160 * 3) * i + 28, 4);
		CopyMemory(&g_aenEnemy[i].iDEX, lpBuf + iEnemyOffset + (16 + 24 + 160 * 160 * 3) * i + 32, 4);
		CopyMemory(&g_aenEnemy[i].iEXP, lpBuf + iEnemyOffset + (16 + 24 + 160 * 160 * 3) * i + 36, 4);

		CopyMemory(g_aenEnemy[i].abyPixels, lpBuf + iEnemyOffset + (16 + 24 + 160 * 160 * 3) * i + 16 + 24, 160 * 160 * 3);

	}

	/* _CAOݒ */
	for (i = 0;i < 16;i++) {

		initDialog(&g_adlgDialog[i],
		   (LPCTSTR)(lpBuf + iDialogOffset + i * 129 + 1),
		   (LPCTSTR)(lpBuf + iDialogOffset + i * 129 + 33),
		   (LPCTSTR)(lpBuf + iDialogOffset + i * 129 + 65),
		   (LPCTSTR)(lpBuf + iDialogOffset + i * 129 + 97),
		   lpBuf[iDialogOffset + i * 129]);

	}

	/* XgOe[uݒ */
	CopyMemory(g_lpStringTable, lpBuf + iStringTableOffset, 256 * 256);

	/* }bv`bvsNZݒ */
	for (i = 0;i < 4;i++) {
		for (j = 0;j < 4;j++) {

			lppxBMP = (LPBYTE)lpBuf + j * 32 * 3 + ((3 - i) * 32) * 128 * 3 + iMapTipOffset;
			lppxParts = g_alppxTips[j + i * 4];

			/* 24rbg32rbgɕϊA㉺]Ȃ] */
			for (k = 0;k < 32;k++) {
				for (l = 0;l < 32;l++) {
					CopyMemory(lppxParts + l + (31- k) * 32,
					           lppxBMP + l * 3 + k * 128 * 3, 3);
				}
			}
		}

	}

	for (i = 0;i < 4;i++) {
		for (j = 0;j < 4;j++) {

			lppxBMP = (LPBYTE)lpBuf + j * 32 * 3 + ((3 - i) * 32) * 128 * 3 + iChrPixelOffset;
			lppxChr = g_alppxChr[j + i * 4];

			/* 24rbg32rbgɕϊA㉺]Ȃ] */
			for (k = 0;k < 32;k++) {
				for (l = 0;l < 32;l++) {
					CopyMemory(lppxChr + l + (31- k) * 32,
					           lppxBMP + l * 3 + k * 128 * 3, 3);
				}
			}
		}

	}

	/* }bvf[^ݒ */
	CopyMemory(&g_abyMap, lpBuf + iMapDataOffset, 256 * 256);
	CopyMemory(&g_abyEvent, lpBuf + iMapEventOffset, 256 * 256);
	CopyMemory(&g_abyEnemy, lpBuf + iMapEnemyOffset, 256 * 256);
	CopyMemory(&g_abyInfo, lpBuf + iMapInfoOffset, 256 * 256);

	return TRUE;

}

/* Cxgs֐ */
void event(int iNo) {

	execEventCode(g_aevEvent[iNo].abyCode);

}

/* CxgR[hs֐ */
void execEventCode(LPBYTE lpCode) {

	int iIndex;
	BOOL bExit;

	iIndex = 0;
	bExit = FALSE;

	do {

		/* CxgR[h|C^sȂI */
		if (iIndex < 0 || iIndex > 63) {
			break;
		}

		switch (lpCode[iIndex]) {

		case CODE_LET: /* WX^l */

			g_awReg[lpCode[iIndex + 1]] = *(LPWORD)(lpCode + iIndex + 2);

			iIndex += 4;

			break;

		case CODE_LETR: /* WX^ԑ */

			g_awReg[lpCode[iIndex + 1]] = g_awReg[lpCode[iIndex + 2]];

			iIndex += 3;

			break;

		case CODE_INC: /* WX^CNg */

			if (g_awReg[lpCode[iIndex + 1]] < 0xffff) {
				g_awReg[lpCode[iIndex + 1]]++;
			}

			iIndex += 2;

			break;

		case CODE_DEC: /* WX^fNg */

			if (g_awReg[lpCode[iIndex + 1]] > 0x0000) {
				g_awReg[lpCode[iIndex + 1]]--;
			}

			iIndex += 2;

			break;

		case CODE_ADD: /* WX^lZ */

			if (g_awReg[lpCode[iIndex + 1]] + *(LPWORD)(lpCode + iIndex + 2) > 0xffff) {
				g_awReg[lpCode[iIndex + 1]] = 0xffff;
			} else {
				g_awReg[lpCode[iIndex + 1]] += *(LPWORD)(lpCode + iIndex + 2);
			}

			iIndex += 4;

			break;

		case CODE_SUB: /* WX^lZ */

			if (g_awReg[lpCode[iIndex + 1]] - *(LPWORD)(lpCode + iIndex + 2) < 0) {
				g_awReg[lpCode[iIndex + 1]] = 0x0000;
			} else {
				g_awReg[lpCode[iIndex + 1]] -= *(LPWORD)(lpCode + iIndex + 2);
			}

			iIndex += 4;

			break;

		case CODE_ADDR: /* WX^Z */

			if (g_awReg[lpCode[iIndex + 1]] + g_awReg[lpCode[iIndex + 2]] > 0xffff) {
				g_awReg[lpCode[iIndex + 1]] = 0xffff;
			} else {
				g_awReg[lpCode[iIndex + 1]] += g_awReg[lpCode[iIndex + 2]];
			}

			iIndex += 3;

			break;

		case CODE_SUBR: /* WX^Z */

			if (g_awReg[lpCode[iIndex + 1]] - g_awReg[lpCode[iIndex + 2]] < 0x0000) {
				g_awReg[lpCode[iIndex + 1]] = 0x0000;
			} else {
				g_awReg[lpCode[iIndex + 1]] -= g_awReg[lpCode[iIndex + 2]];
			}

			iIndex += 3;

			break;

		case CODE_JP: /* Wv */

			iIndex += lpCode[iIndex + 1];

			break;

		case CODE_JPEQ: /* Wv */

			if (g_awReg[lpCode[iIndex + 1]] == *(LPWORD)(lpCode + iIndex + 2)) {
			
				if (lpCode[iIndex + 4] < 0x80) {
					iIndex += lpCode[iIndex + 4];
				} else {
					iIndex -= lpCode[iIndex + 4] & 0x7f;
				}

			} else {
				iIndex += 5;
			}

			break;

		case CODE_JPEQR: /* Wv */

			if (g_awReg[lpCode[iIndex + 1]] == g_awReg[lpCode[iIndex + 2]]) {

				if (lpCode[iIndex + 3] < 0x80) {
					iIndex += lpCode[iIndex + 3];
				} else {
					iIndex -= lpCode[iIndex + 3] & 0x7f;
				}

			} else {
				iIndex += 4;
			}

			break;

		case CODE_JPLT: /* Wv */

			if (g_awReg[lpCode[iIndex + 1]] < *(LPWORD)(lpCode + iIndex + 2)) {

				if (lpCode[iIndex + 4] < 0x80) {
					iIndex += lpCode[iIndex + 4];
				} else {
					iIndex -= lpCode[iIndex + 4] & 0x7f;
				}

			} else {
				iIndex += 5;
			}

			break;

		case CODE_JPLTR: /* Wv */

			if (g_awReg[lpCode[iIndex + 1]] < g_awReg[lpCode[iIndex + 2]]) {

				if (lpCode[iIndex + 3] < 0x80) {
					iIndex += lpCode[iIndex + 3];
				} else {
					iIndex -= lpCode[iIndex + 3] & 0x7f;
				}

			} else {
				iIndex += 4;
			}

			break;

		case CODE_JPGT: /* Wv */

			if (g_awReg[lpCode[iIndex + 1]] > *(LPWORD)(lpCode + iIndex + 2)) {

				if (lpCode[iIndex + 4] < 0x80) {
					iIndex += lpCode[iIndex + 4];
				} else {
					iIndex -= lpCode[iIndex + 4] & 0x7f;
				}

			} else {
				iIndex += 5;
			}

			break;

		case CODE_JPGTR: /* Wv */

			if (g_awReg[lpCode[iIndex + 1]] > g_awReg[lpCode[iIndex + 2]]) {

				if (lpCode[iIndex + 3] < 0x80) {
					iIndex += lpCode[iIndex + 3];
				} else {
					iIndex -= lpCode[iIndex + 3] & 0x7f;
				}

			} else {
				iIndex += 4;
			}

			break;

		case CODE_JPNEQ: /* Wv */

			if (g_awReg[lpCode[iIndex + 1]] != *(LPWORD)(lpCode + iIndex + 2)) {
			
				if (lpCode[iIndex + 4] < 0x80) {
					iIndex += lpCode[iIndex + 4];
				} else {
					iIndex -= lpCode[iIndex + 4] & 0x7f;
				}

			} else {
				iIndex += 5;
			}

			break;

		case CODE_MESSAGE: /* bZ[W\ */

			showMessage(g_alpszString[lpCode[iIndex + 1]]);

			iIndex += 2;

			drawGame();
			InvalidateRect(g_hwMain, NULL, FALSE);

			break;

		case CODE_MESSAGER: /* bZ[W\ */

			showMessage(g_alpszString[g_awReg[lpCode[iIndex + 1]]]);

			iIndex += 2;

			drawGame();
			InvalidateRect(g_hwMain, NULL, FALSE);

			break;

		case CODE_DIALOG: /* I_CAO\ */

			g_awReg[lpCode[iIndex + 2]] = dialog(lpCode[iIndex + 1]);

			iIndex += 3;

			break;

		case CODE_BATTLE: /* 퓬 */

			g_awReg[lpCode[iIndex + 2]] = battle(&g_aenEnemy[lpCode[iIndex + 1]]);

			iIndex += 3;

			break;

		case CODE_MOVE: /* ړ */

			setXY(lpCode[iIndex + 1], lpCode[iIndex + 2]);

			iIndex += 3;

			break;

		case CODE_SETMAP: /* }bvݒ */

			g_abyMap[lpCode[iIndex + 1] + lpCode[iIndex + 2] * 256] = lpCode[iIndex + 3];

			iIndex += 4;

			break;

		case CODE_SETEVENT: /* Cxgݒ */

			g_abyEvent[lpCode[iIndex + 1] + lpCode[iIndex + 2] * 256] = lpCode[iIndex + 3];

			iIndex += 4;

			break;

		case CODE_SETINFO: /* n`ݒ */

			g_abyInfo[lpCode[iIndex + 1] + lpCode[iIndex + 2] * 256] = lpCode[iIndex + 3];

			iIndex += 4;

			break;

		case CODE_HPMAX: /* vC[̗͑S */

			g_status.iHP = g_status.iHPMax;

			drawStatus();

			iIndex++;

			break;

		case CODE_EXIT: /* I */

			bExit = TRUE;

			break;

		}

		if (g_bExit) {
			return;
		}

		Sleep(1);

	} while (!bExit && !g_bExit);

	if (!g_bExit) {

		drawGame();
		InvalidateRect(g_hwMain, NULL, FALSE);

	}

}

/* vC[Xe[^XČvZ֐ */
void clcStatus() {

	g_status.iHPMax = g_status.iHPMaxL + (int)sqrt(g_status.iEXP);
	g_status.iAT = g_status.iATL + (int)sqrt(g_status.iEXP);
	g_status.iAC = g_status.iACL + (int)sqrt(g_status.iEXP);
	g_status.iDEX = g_status.iDEXL + (int)sqrt(g_status.iEXP);

}

/* I֐ */
BOOL destroy() {

	int i;

	/* obt@ */
	HeapFree(GetProcessHeap(), 0, g_lppxChr);
	HeapFree(GetProcessHeap(), 0, g_lppxTip);
	HeapFree(GetProcessHeap(), 0, g_lpStringTable);

	/* Q[rbg}bv폜 */
	SelectObject(g_hdcGame, g_hbmpGameOld);
	DeleteObject(g_hbmpGame);
	DeleteDC(g_hdcGame);

	/* }bvrbg}bv폜 */
	SelectObject(g_hdcMap, g_hbmpMapOld);
	DeleteObject(g_hbmpMap);
	DeleteDC(g_hdcMap);

	/* Xe[^Xrbg}bv폜 */
	SelectObject(g_hdcStatus, g_hbmpStatusOld);
	DeleteObject(g_hbmpStatus);
	DeleteDC(g_hdcStatus);

	/* _CAOrbg}bv폜 */
	for (i = 0;i < 16;i++) {
		if (g_adlgDialog[i].iItems > 0) {

			SelectObject(g_adlgDialog[i].hdc, g_adlgDialog[i].hbmpOld);
			DeleteObject(g_adlgDialog[i].hbmpWnd);

			DeleteDC(g_adlgDialog[i].hdc);

		}
	}

	/* bZ[WEChErbg}bv폜 */
	SelectObject(g_mwMessage.hdc, g_mwMessage.hbmpOld);
	DeleteObject(g_mwMessage.hbmpWnd);
	DeleteDC(g_mwMessage.hdc);

	return TRUE;

}
